/****************************************************************************
*   Copyright 1999, Caldera Thin Client Systems, Inc.                       *
*   This software is licensed under the GNU Public License.                 *
*   See LICENSE.TXT for further information.                                *
*                                                                           *
*   Historical Copyright                                                    *
*                                                                           *
*   Copyright (c) 1985,1991  Digital Research Inc.  All rights reserved.    *
*   The Software Code contained in this listing is proprietary to Digital   *
*   Research Inc., Monterey, California, and is covered by U.S. and other   *
*   copyright protection.  Unauthorized copying, adaption, distribution,    *
*   use or display is prohibited and may be subject to civil and criminal   *
*   penalties.  Disclosure to others is prohibited.  For the terms and      *
*   conditions of software code use, refer to the appropriate Digital       *
*   Research License Agreement.						    *
*****************************************************************************
*		      U.S. GOVERNMENT RESTRICTED RIGHTS			    *
*                    ---------------------------------                      *
*  This software product is provided with RESTRICTED RIGHTS.  Use, 	    *
*  duplication or disclosure by the Government is subject to restrictions   *
*  as set forth in FAR 52.227-19 (c) (2) (June, 1987) when applicable or    *
*  the applicable provisions of the DOD FAR supplement 252.227-7013 	    *
*  subdivision (b)(3)(ii) (May 1981) or subdivision (c)(1)(ii) (May 1987).  *
*  Contractor/manufacturer is Digital Research Inc. / 70 Garden Court /     *
*  BOX DRI / Monterey, CA 93940.					    *
*****************************************************************************
* $Header: m:/davinci/users//groups/panther/dsk/rcs/gsxdefs.h 4.1 92/01/06 13:11:45 anderson Exp $
* $Log:	gsxdefs.h $
 * Revision 4.1  92/01/06  13:11:45  anderson
 * Color icon work from Becky.
 * 
 * Revision 3.1  91/08/19  16:31:24  system
 * ViewMAX 2 sources
 * 
* Revision 3.2  91/06/04  13:01:54  sbc
* misc housekeeping and other ravings...
* 
* Revision 3.1  91/05/16  14:48:06  fontes
* Separate branch for Beta bug fixes, separate from split-mode windows
* 
* Revision 2.1.1.3  91/04/08  12:00:55  fontes
* Re-activate some calls needed for list boxes and other ext. objects
* 
* Revision 2.1.1.2  91/03/25  14:41:01  anderson
* Converted to medium model, prototyped, and generally cleaned up.
* 
*****************************************************************************/

/****************************************************************************
* File:		gsxdefs.h
*
* Description:	
*
* Build Info:	ndmake -f vm2.mak
*
* Overview:	GSXDEFS.H	05/06/84 - 12/08/84	Lee Lorenzen
*  
*****************************************************************************/


typedef struct wsstr    /* work station parameters */
{
	WORD		ws_xres;	/* maximum addressable width	*/
	WORD		ws_yres;	/* maximum addressable height	*/
	WORD		ws_noscale;	/* precision flag		*/
	WORD		ws_wpixel;	/* pixel width			*/
	WORD		ws_hpixel;	/* pixel width			*/
	WORD		ws_ncheights;	/* Number of character heights	*/
	WORD		ws_nlntypes;	/* number of line types		*/
	WORD		ws_nlnwidths;	/* number of line widths	*/
	WORD		ws_nmktypes;	/* number of marker types	*/
	WORD		ws_nmksizes;	/* number of marker sizes	*/
	WORD		ws_nfaces;	/* number of faces supported	*/
	WORD		ws_npatts;	/* number of patterns		*/
	WORD		ws_nhatchs;	/* number of hatches		*/
	WORD		ws_ncolors;	/* number of colors		*/
	WORD		ws_ngdps;	/* number of GDP'S		*/
	WORD		ws_supgdps[10]; /* list of available GDP's	*/
	WORD		ws_attgdps[10]; /* attributes associated with each gdp */
	WORD		ws_color;	/* color capablity		*/
	WORD		ws_rotate;	/* text rotation		*/
	WORD		ws_fill;	/* fill capablity		*/
	WORD		ws_cell;	/* Cell array capablity		*/
	WORD		ws_npals;	/* Number of available colors	*/
	WORD		ws_nloc;	/* Number of locator devices	*/
	WORD		ws_nval;	/* Number of valuator devices	*/
	WORD		ws_nchoice;	/* Number of choice devices	*/
	WORD		ws_nstring;	/* Number of string devices	*/
	WORD		ws_type;	/* Work station type		*/
	WORD		ws_pts0;	/* minimum character width	*/
	WORD		ws_chminh;	/* minimum character height	*/
	WORD		ws_pts2;	/* maximum character width	*/
	WORD		ws_chmaxh;	/* maximum character height	*/
	WORD		ws_lnminw;	/* minimum line width		*/
	WORD		ws_pts5;	/* unused			*/
	WORD		ws_lnmaxw;	/* maximum line width		*/
	WORD		ws_pts7;	/* unused			*/
	WORD		ws_pts8;	/* minimum marker width		*/
	WORD		ws_mkminw;	/* minimum marker height	*/
	WORD		ws_pts10;	/* maximum marker width		*/
	WORD		ws_mkmaxw;	/* maximum marker height	*/
} WS;

typedef struct ex_statn /* extended work station parameters */
{
	WORD		scr_type;	/* Screen type  */
	WORD		num_bclr;	/* Number of backgroud colors */
	WORD		text_effs;	/* Text effects supported */
	WORD		scal_rast;	/* scaling of rasters */
	WORD		num_planes;	/* Number of planes */
	WORD		look_up;	/* Look up table support */
	WORD		preffrmc;	/* performance factor */
	WORD		cntr_fill;	/* contour fill capablity */
	WORD		char_rot;	/* character rotation capablity */
	WORD		num_wmode;	/* Number of writing modes */
	WORD		inp_mode;	/* Highest level of input mode supported */
	WORD		text_algn;	/* text alignment capability	*/
	WORD		ink_cap;	/* Inking capablity */
	WORD		rub_cap;	/* rubberbanding capablity */
	WORD		max_points;	/* maximum number of points */
	WORD		max_intin;	/* maximum intin size */
	WORD		num_mbut;	/* number of buttons available on the mouse */
	WORD		wline_sty;	/* Style available for wide lines */
	WORD		wline_mode;	/* Writing modes for wide lines */
	WORD		clip_cap;	/* Clipping flag		        */
	WORD		px_units;	/* Units for extended pixel size*/
	WORD		ex_xpix;	/* Width of pixel		       */
	WORD		ex_ypix;	/* Height of pixel	          */
	WORD		x_dots;		/* Horizontal dots per inch     */
	WORD		y_dots;		/* Vertical dots per inch       */
	WORD		bi_rot;		/* Bit image rotation flag      */
	WORD		unused[31];	/* Unused */
} EX_STAT;

typedef struct fdbstr
{
	LONG		fd_addr;	/* memory pointer	*/
	UWORD		fd_w;		/* width in pixels	*/
	UWORD		fd_h;		/* height in pixels	*/
	UWORD		fd_wdwidth;	/* width in words	*/
	UWORD		fd_stand;	/* format		*/
	UWORD		fd_nplanes;	/* memory planes	*/
	UWORD		fd_r1;		/* reserved		*/
	UWORD		fd_r2;
	UWORD		fd_r3;
} FDB;


typedef struct mfstr
{
	WORD	mf_xhot;
	WORD	mf_yhot;
	WORD	mf_nplanes;
	WORD	mf_fg;
	WORD	mf_bg;
	WORD	mf_mask[16];
	WORD	mf_data[16];
} MFORM ;


typedef struct scrdev           /* Screen Driver info   */
{
    WORD    sc_handle;      /* Screen workstation handle	*/
    FDB     sc_mfdb;	    /* Screen Mem From Defn Block	*/
    FBYTE   *sc_qbuff;      /* Pointer to quarter screen buffer */
    LONG    sc_qlength;     /* Length of quarter screen buffer  */
    UWORD   sc_pwidth;      /* width of pixel			*/
    UWORD   sc_pheight;     /* height of pixel			*/
    WORD    sc_mn_chgt;     /* Minimum character height		*/
    WORD    sc_mx_chgt;     /* Maximum character height		*/
    WORD    sc_mx_clhgt;    /* Maximum cell height		*/
    WORD    sc_mx_points;   /* Maximum points in polyline,etc.  */
} SCRN;
/*
 *	EOF:	gsxdefs.h
 */
