/****************************************************************************
*   Copyright 1999, Caldera Thin Client Systems, Inc.                       *
*   This software is licensed under the GNU Public License.                 *
*   See LICENSE.TXT for further information.                                *
*                                                                           *
*   Historical Copyright                                                    *
*                                                                           *
*   Copyright (c) 1985,1991  Digital Research Inc.  All rights reserved.    *
*   The Software Code contained in this listing is proprietary to Digital   *
*   Research Inc., Monterey, California, and is covered by U.S. and other   *
*   copyright protection.  Unauthorized copying, adaption, distribution,    *
*   use or display is prohibited and may be subject to civil and criminal   *
*   penalties.  Disclosure to others is prohibited.  For the terms and      *
*   conditions of software code use, refer to the appropriate Digital       *
*   Research License Agreement.						    *
*****************************************************************************
*		      U.S. GOVERNMENT RESTRICTED RIGHTS			    *
*                    ---------------------------------                      *
*  This software product is provided with RESTRICTED RIGHTS.  Use, 	    *
*  duplication or disclosure by the Government is subject to restrictions   *
*  as set forth in FAR 52.227-19 (c) (2) (June, 1987) when applicable or    *
*  the applicable provisions of the DOD FAR supplement 252.227-7013 	    *
*  subdivision (b)(3)(ii) (May 1981) or subdivision (c)(1)(ii) (May 1987).  *
*  Contractor/manufacturer is Digital Research Inc. / 70 Garden Court /     *
*  BOX DRI / Monterey, CA 93940.					    *
*****************************************************************************
* $Header: m:/davinci/users//groups/panther/dsk/rcs/portab.h 3.2 92/04/03 17:13:23 sbc Exp $
* $Log:	portab.h $
 * Revision 3.2  92/04/03  17:13:23  sbc
 * WNODEs and PNODEs to fars, lots of other housekeeping
 * 
 * Revision 3.1  91/08/19  16:30:16  system
 * ViewMAX 2 sources
 * 
Date	Who	SPR#	Comments
-------	-------	----	-------------------------------------------------------
910426	RSF		Add long nullptr
910405	RSF		Add in SLONG for those who use signed long values.
910321	RSF		Add in far and near defines.
*****************************************************************************/

#ifndef PORTAB_INCLUDED
#define PORTAB_INCLUDED

/*
 *	Standard type definitions
 */
#define	BYTE	char				/* Signed byte		   */
#define BOOLEAN	int				/* 2 valued (true/false)   */
#define	WORD	int  				/* Signed word (16 bits)   */
#define	UWORD	unsigned int			/* unsigned word	   */

#define	LONG	unsigned long			/* signed long (32 bits)   */
#define	ULONG	unsigned long			/* Unsigned long	   */
#define	SLONG	long				/* signed long		   */

#define	REG	register			/* register variable	   */
#define	EXTERN	extern				/* External variable	   */
#define	MLOCAL	static				/* Local to module	   */
#define	GLOBAL	/**/				/* Global variable	   */
#define	VOID	void				/* Void function return	   */
#define UBYTE	unsigned char	

#define	FBYTE		BYTE FAR
#define	FWORD		WORD FAR

/****************************************************************************/
/*	Miscellaneous Definitions:					    */
/****************************************************************************/
#define	NULL	0			/*	Null pointer value	    */
#define	TRUE	(1)			/*	Function TRUE  value	    */
#define	FALSE	(0)			/*	Function FALSE value	    */
#define SET	(2)			/*	Set flags to this value.    */
#define ON	(1)			/*	"TRUE"			    */
#define OFF	(0)			/*	"FALSE"			    */

#endif /* ndef PORTAB_INCLUDED */

/*
*	EOF:	portab.h
*/
